#include <htc.h>
#include "../main/isr.h"
#include "../hardware/display.h"
#include "../hardware/resistors.h"

volatile unsigned int tmr1_overflow;

enum TMR0_INTERRUPT_MODES tmr0_interrupt_mode = TMR0_INTERRUPT_MODE_DISPLAY_OUTPUT_SEGMENT;

// Frequency of the square wave.
unsigned int square_wave_frequency;
// Reference base frequency of the square wave.
unsigned int square_wave_reference_frequency;
// Square wave accumulator.
volatile int square_wave_accumulator;

void interrupt isr(void) {
    if (TMR0IF) {
        TMR0IF = 0;
		switch (tmr0_interrupt_mode) {
			case TMR0_INTERRUPT_MODE_DISPLAY_OUTPUT_SEGMENT:
				display_output_segment();
				break;
			case TMR0_INTERRUPT_MODE_SQUARE_WAVE:
				square_wave_accumulator -= square_wave_frequency;
				if (square_wave_accumulator < 0) {
					R20 = !R20;
					square_wave_accumulator += square_wave_reference_frequency;
				}
				break;
		}
		return;
    }
	if (TMR1IF) {
		TMR1IF = 0;
		++tmr1_overflow;
		return;
	}
}