#include <htc.h>
#include "../main/settings.h"
#include "../modes/modes.h"
#include "../modes/pulser.h"

// Global settings.
struct probe_settings settings;

// Loads settings from EEPROM.
void settings_load(void) {
	unsigned char* p = &settings;
	for (unsigned int address = 0; address < sizeof(struct probe_settings); ++address) {
		*p++ = eeprom_read(address);
	}
	// Ensure that the settings are valid.
	if (settings.mode >= PROBE_MODE_COUNT) {
		settings.mode = 0;
	}
	if (settings.pulser_rate >= PULSER_RATES_COUNT) {
		settings.pulser_rate = 0;
	}
	if (settings.square_wave_frequency < 1 || settings.square_wave_frequency > 9999) {
		settings.square_wave_frequency = 440;
	}
}

// Saves settings to EEPROM.
void settings_save(void) {
	unsigned char* p = &settings;
	for (unsigned int address = 0; address < sizeof(struct probe_settings); ++address) {
		unsigned char old_eeprom_data = eeprom_read(address);
		if (old_eeprom_data != *p) {
			eeprom_write(address, *p);
		}
		++p;
	}
}