#include <htc.h>
#include "../hardware/display.h"
#include "../hardware/buttons.h"
#include "../hardware/resistors.h"

unsigned long event_count_overflow = 0;

void counter_reset(void) {
	event_count_overflow = 0;
	TMR0 = 0;
	TMR0IF = 0;
}

void event_counter(void) {
	
	di();

	// Use an external clock source.
	T0CS = 1;

	// Apply a weak pull-up.
	R100K = 1;
	TRIS_R100K = 0;


	counter_reset();

	unsigned long event_count;
	unsigned char read_tmr0, read_tmr0if;

	while (BUTTON_1 || BUTTON_2) {
		
		// Read the timer.
		read_tmr0 = TMR0;
		read_tmr0if = TMR0IF;

		// Interrupt?
		if (read_tmr0if) {
			++event_count_overflow;
			TMR0IF = 0;
		}
		event_count = (event_count_overflow << 8) | read_tmr0;

		// Reset the counter if need be.
		if (!BUTTON_2) {
			counter_reset();
			event_count = 0;
		}

		// Display the count.
		if (BUTTON_1) {
			display_print_decimal(0x8000 | (event_count % 10000));
		} else {
			display_print_decimal(0x8000 | (event_count / 10000));
		}

		// Refresh the display.
		display_output_segment();
	}

	// Use the internal clock source.
	T0CS = 0;

	ei();
}